> For the complete documentation index, see [llms.txt](https://docs.zama.org/concrete/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.zama.org/concrete/guides/manage_keys.md).

# Manage keys

This document explains how to manage keys when using **Concrete**, introducing the key management API for generating, reusing, and securely handling keys.

**Concrete** generates keys lazily when needed. While this is convenient for development, it's not ideal for the production environment. The explicit key management API is available for you to easily generate and reuse keys as needed.

## Definition

Let's start by defining a circuit with the following example:

```python
from concrete import fhe

@fhe.compiler({"x": "encrypted"})
def f(x):
    return x ** 2

inputset = range(10)
circuit = f.compile(inputset)
```

Circuits have a `keys` property of type `fhe.Keys`, which includes several utilities for key management.

## Generation

To explicitly generate keys for a circuit, use:

```python
circuit.keys.generate()
```

{% hint style="info" %}
Generated keys are stored in memory and remain unencrypted.
{% endhint %}

You can also set a custom seed for reproducibility:

```python
circuit.keys.generate(seed=420)
```

{% hint style="warning" %}
Do not specify the seed manually in a production environment! This is not secure and should only be done for debugging purposes.
{% endhint %}

## Serialization

To serialize keys, for tasks such as sending them across a network, use:

```python
serialized_keys: bytes = circuit.keys.serialize()
```

{% hint style="warning" %}
Keys are not serialized in encrypted form. Please make sure you keep them in a safe environment, or encrypt them manually after serialization.
{% endhint %}

## Deserialization

To deserialize the keys back after receiving serialized keys, use:

```python
keys: fhe.Keys = fhe.Keys.deserialize(serialized_keys)
```

## Assignment

Once you have a valid `fhe.Keys` object, you can directly assign it to the circuit:

```python
circuit.keys = keys
```

{% hint style="warning" %}
If assigned keys are generated for a different circuit, an exception will be raised.
{% endhint %}

## Saving

You can also use the filesystem to store the keys directly, without managing serialization and file management manually:

```python
circuit.keys.save("/path/to/keys")
```

{% hint style="warning" %}
Keys are not saved in encrypted form. Please make sure you store them in a safe environment, or encrypt them manually after saving.
{% endhint %}

## Loading

After saving keys to disk, you can load them back using:

```python
circuit.keys.load("/path/to/keys")
```

## Automatic Management

If you want to generate keys in the first run and reuse the keys in consecutive runs, use:

```python
circuit.keys.load_if_exists_generate_and_save_otherwise("/path/to/keys")
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.zama.org/concrete/guides/manage_keys.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
